/* Copyright (c) 2006, National ICT Australia
 * All rights reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Authors      : Choon Hui Teo       (ChoonHui.Teo@nicta.com.au)
 *                Quoc V. Le          (Quoc.Le@nicta.com.au)
 *                Alex Smola          (Alex.Smola@nicta.com.au)
 *                S.V.N. Vishwanathan (SVN.Vishwanathan@nicta.com.au)        
 *
 * Created      : 18/12/2006
 *
 * Last Updated :
 */

#ifndef _INPUTOUTPUT_HPP_
#define _INPUTOUTPUT_HPP_

#include <iostream>
#include <iomanip>
#include <string>
#include <fstream>
#include <sstream>
#include <unistd.h>
#include <cassert>

#include "errorcode.hpp"
#include "common.hpp"
#include "info.hpp"
#include "dataset.hpp"
#include "matvecarr.hpp"

using namespace std;

void ParseCmdLineArgPredict(int argc, char** argv, CInfo* info);
void ParseCmdLineArgTrain(int argc, char** argv, CInfo* info);

void PrintLossOptions();
void PrintPredictUsageMessage();
void PrintTrainUsageMessage();

ErrorCode WriteModelFile(CMatVecArr* w, CInfo* info, string _fn="");
ErrorCode ReadModelFile(CMatVecArr* &w, CInfo* info, string _fn="");

#endif
