/* Copyright (c) 2006, National ICT Australia
 * All rights reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Authors      : Choon Hui Teo       (ChoonHui.Teo@nicta.com.au)
 *                Quoc V. Le          (Quoc.Le@nicta.com.au)
 *                Alex Smola          (Alex.Smola@nicta.com.au)
 *                S.V.N. Vishwanathan (SVN.Vishwanathan@nicta.com.au)        
 *
 * Created      : 26/02/2007
 *
 * Last Updated :
 */

#ifndef _LOSS_HEADER_HPP_
#define _LOSS_HEADER_HPP_

// various loss abstract classes
#include "loss.hpp"
#include "scalarloss.hpp"
#include "scalarclassificationloss.hpp"
#include "scalarregressionloss.hpp"
#include "scalarrankingloss.hpp"

/*
 *   All loss function files are in the directory loss/
 */

// binary classification losses
#include "softmarginloss.hpp"
#include "squaredsoftmarginloss.hpp"
#include "huberhingeloss.hpp"
#include "logisticloss.hpp"
#include "exponentialloss.hpp"
#include "rocscoreloss.hpp"
#include "fbetascoreloss.hpp"


// univariate regression
#include "esvrloss.hpp"
#include "huberloss.hpp"
#include "leastsquaresloss.hpp"
#include "leastdeviationloss.hpp"

// other scalarloss
#include "quantileloss.hpp"
#include "noveltyloss.hpp"
#include "poissonloss.hpp"


/* ranking */
#include "ndcgloss.hpp"
#include "ordinalregressionloss.hpp"

#endif
