/* Copyright (c) 2006, National ICT Australia
 * All rights reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Authors      : Choon Hui Teo       (ChoonHui.Teo@nicta.com.au)
 *                Quoc V. Le          (Quoc.Le@nicta.com.au)
 *                Alex Smola          (Alex.Smola@nicta.com.au)
 *                S.V.N. Vishwanathan (SVN.Vishwanathan@nicta.com.au)        
 *
 * Created      : 26/02/2007
 *
 * Last Updated :
 */

#ifndef _SOLVER_HEADER_HPP_
#define _SOLVER_HEADER_HPP_

/*
 *   All solver files are in the directory solver/
 */

// abstract class
#include "solver.hpp"

// Dai-Fletcher Projected Gradient QP solver
#include "daifletcherpgm.hpp"

// Interior Point Method (LOQO) QP solver
#include "prloqo.hpp"

// CG solver
#include "cg.hpp"

// 1-norm Linear programming solver
#include "l1clp.hpp"

// linear programming solver (for cutting plane methods)
#include "cuttingplane.hpp"


#endif
