/* Copyright (c) 2006, National ICT Australia
 * All rights reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Authors      : Choon Hui Teo       (ChoonHui.Teo@nicta.com.au)
 *                Quoc V. Le          (Quoc.Le@nicta.com.au)
 *                Alex Smola          (Alex.Smola@nicta.com.au)
 *                S.V.N. Vishwanathan (SVN.Vishwanathan@nicta.com.au)        
 *
 * Created      : 18/04/2007
 *
 * Last Updated :
 */

#ifndef _SOLVER_SWITCH_HPP_
#define _SOLVER_SWITCH_HPP_

#include "solver_header.hpp"
#include "info.hpp"


/**  Select solver
 *
 */
CSolver* SelectSolver(CInfo *info)
{
  switch(info->solverType) { 
  case DAIFLETCHER :   return new CDaiFletcherPGM(info, 1e-5); 
  case QPLOQO :        return new CprLOQO(info, 1e-5);
  case L1LP :          return new CL1Clp(info); 
  case CUTTING_PLANE : return new CCuttingPlane(info); 
  default : 
    printf("ERROR: invalid solver type !\n");
    exit(EXIT_FAILURE);    
  }
}

#endif
